<?php
	
/* Special fields of Slideshow form (handled by Cu3erHelper::generateHTML method)
 *
 * $special_fields = array(
	'field name' => array(
		'type [type of the field]' => ['colorpicker','genericlist(dropdown)','radiolist','checkbox','image','textarea'],
		'value [value(s) of the field]' => [string, array],
		'label [label(s) of the field if you want it to be different from value, (eg <option value="10">ten</option>)]' => [string, array],
		'display_name [displaying name of the field]' => [true, false],
		'uncheck_value [requested value if field is checkbox and unchecked (eg: 'no' or false)]' => [string],
	)
 * )	
 * If a field is not in special fields array it is generated into <input type="text" value=".." /> element automatically
 */
	$special_fields = array(
		'id' => array(
			'type' => 'string',			
		),		
		'background' => array(
			'type' => 'colorpicker',
		),
		'force_js' => array(
			'type' => 'checkbox',
			'value' => array(
				'true',
			),
			'uncheck_value' => 'false',
			'label' => array(
				'Force display Javascript',
			),
			'display_name' => false,
		),
		'content' => array(
			'type' => 'textarea',
		),
		'backgroundType' => array(
			'type' => 'radiolist',
			'value' => array(
				'transparent',
				'color',
			),
		),
		'bg_image' => array(
			'type' => 'image',
			'condition' => array(
				'field' => 'bg_use_image',
				'value' => 'true',
			),		
			'display_name' => false,
		),
		'sdw_image' => array(
			'type' => 'image',
			'condition' => array(
				'field' => 'sdw_use_image',
				'value' => 'true',
			),		
			'display_name' => false,
		),
		'pr_image' => array(
			'type' => 'image',
			'condition' => true,
			'display_name' => false,
		),
		'modified' => array(
			'type' => 'string',		
		),
		'published' => array(
			'type' => 'checkbox',
			'value' => array(
				1,
			),
			'label' => array(
				'published',
			),
			'display_name' => false,
		),
	);
	
	// Parameters which don't appear for user in the settings form
	$hidden_fields = array( '_tbl', '_tbl_key', '_db', '_errors', 'type', 'xml_location', 
				'bg_align_to', 'bg_align_pos', 'bg_x', 'bg_y', 'bg_scalex', 'bg_scaley', 'bg_use_image', 'sdw_show', 
				'sdw_use_image', 'sdw_color', 'sdw_alpha', 'sdw_blur', 'sdw_corner_tl', 'sdw_corner_tr', 
				'sdw_corner_bl', 'sdw_corner_br', 'sdw_image', 'pr_image', 'pr_align_to', 'pr_align_pos', 'pr_x', 'pr_y',
				'pr_scalex', 'pr_scaley', 'pr_loader_direction', 'pr_alpha_loader', 'pr_alpha_bg', 
				'br_align_to', 'br_align_pos', 'br_x', 'br_y', 'pr_tint_loader', 'pr_tint_bg', 'pr_width', 'pr_height');

	// Parameter groups (first element's name => group name)
	$field_groups = array(
		'width' => 'swf size',
		'images_folder' => 'folder locations',
		'bg_image' => 'Background',
		'sdw_image' => 'Shadow',
		'pr_image' => 'Preloader',
		'force_js' => 'alternative content',
	);

?>