<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: setup.php 2011-04-12 05:17:53 svn $
 * @author Tibor Németh
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');
jimport('joomla.filesystem.file');

// Include Slideshow table
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class Cu3erModelSetup extends JModel {

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct() {
		parent::__construct();
	}    	

	/**
	 * Setup data getter method
	 *
	 * @access 	public
	 * @return 	array array of slides
	 */	
	function getData() {
		
		$db = & JFactory::getDBO();

		$query = "SELECT * FROM #__cu3er__settings ";
		
		$db->setQuery($query);
		
		// getting query result object
		$row = $db->loadObject();

		return $row;
	}

	/**
	 * Settings saver method
	 *
	 * @access 	public
	 */	
	function save() {
		
		$files = array();
		
		$files['CU3ER_swf'] = JRequest::getVar('CU3ER_swf_file', '', 'files', 'array');
		$files['jquery_cu3er_js'] = JRequest::getVar('jquery_cu3er_js_file', '', 'files', 'array');
		$files['jquery_cu3er_player_js'] = JRequest::getVar('jquery_cu3er_player_js_file', '', 'files', 'array');

		$post = JRequest::get('post');

		// setting of unchecked branding checkbox value		
		if (!isset($post['branding'])) {
			$post['branding'] = 'no';
		}

		$row = & JTable::getInstance('Cu3erSettings', 'Table');
		// binding, checking and storing posted variables to database
		if (!$row->bind($post) || !$row->check() || !$row->store()) {
			$mainframe->redirect('index.php?option=com_cu3er&view=setup', $row->getError(), 'error');
		}

		$row->checkin();

		$this->updateCu3erFiles($files);
	}

	/**
	 * CU3ER file uploader method
	 *
	 * @access 	public
	 * @param	string	$string name of the file
	 */	
	function updateCu3erFiles($files) {

		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');

		$mainframe = &JFactory::getApplication();
		
		// redirect URL
		$return = 'index.php?option=com_cu3er&view=setup';

		// cycling thru every file
		foreach ($files as $file_type => $file) {
			if ($file['name'] != '') {
				
				// setting upload path
				$filepath = JPATH_COMPONENT_SITE.DS.(($file_type == 'CU3ER_swf')?'flash':'js');
			
				// calling upload handler method of Cu3erFile class
				Cu3erFile::uploadFile($return, ($file_type == 'CU3ER_swf')?'swf':'js', true, $file, $filepath, false);			
			}
		}

		// handling redirection
		$mainframe->enqueueMessage(JText::_('Update complete'));
		$mainframe->redirect($return);
	}

	/**
	 * CU3ER file data getter method
	 *
	 * @access 	public
	 * @param	string	$remote_URL base URL of remote files
	 * @param	array	$files array of files
	 * @return	array	prepared file array
	 */		
	function getFileData($remote_URL, $files) {
		
		// setting file data array
		$filedata = $files;

		// cycling thru every file
		foreach ($filedata as $file => $prop) {

			// checking of file's existence
			$filedata[$file]['exists'] = JFile::exists(JPATH_COMPONENT_SITE.DS.$prop['local_subdir'].DS.$file);

			// adding remote subdirectory to remote URL
			$rURL = $remote_URL . (($prop['url_subdir'] != '')?(DS.$prop['url_subdir']):(''));

			// comparing the versions of local and remote files
			$filedata[$file]['up-to-date'] = ($filedata[$file]['exists'])?$this->compareFileSize(JPATH_COMPONENT_SITE.DS.$prop['local_subdir'].DS.$file, $rURL):true;
		}

		return $filedata;
	}

	/**
	 * CU3ER file size comparing method
	 *
	 * @access 	public
	 * @param	string	$file full path of file
	 * @param	string	$remote_URL URL of the remote file
	 * @return	boolean true if files are identical
	 */		
	function compareFileSize($file, $remote_URL) {		
		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');		

		// getting the filesize of local file		
		$local_size = filesize($file);

		// getting the filesize of remote file
		$remote_size = Cu3erFile::getRemoteFileSize($remote_URL . DS . basename($file));

		// return true if they have the same size
		return ($local_size == $remote_size);

	}

}
