<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: cu3er.php 2011-04-12 05:17:53 svn $
 * @author Tibor Németh
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class Cu3erModelSlideshows extends JModel {
    
    	var $total = null;

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */	
	function __construct() {
		parent::__construct();
    	}

	/**
	 * Slideshow list getter method
	 *
	 * @access public
	 * @return array array of slideshows
	 */	
	function getData() {

		$mainframe = &JFactory::getApplication();		
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');		
		$db = & JFactory::getDBO();

		// setting ORDER BY values
		$filter_order = $mainframe->getUserStateFromRequest($option.$view.'filter_order', 'filter_order', 'id', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.$view.'filter_order_Dir', 'filter_order_Dir', '', 'word');		

		// query string		
		$query = 'SELECT id, name, published, modified, width, height, images_folder FROM #__cu3er__slideshows';
		$query .= " ORDER BY {$filter_order} {$filter_order_Dir}";

		// making query
		$db->setQuery($query);
		// getting query result object
		$rows = $db->loadObjectList();
		
		$this->total = count($rows);
		
		return $rows;
	}

	/**
	 * Slideshow list entry counter method
	 *
	 * @access public
	 * @return int total number of slides in a slideshow
	 */
	function getTotal() {
		return $this->total;	
	}

	/**
	 * Slideshow publisher method
	 *
	 * @access public
	 * @param int $publish publish field value (0 = unpublished, 1 = published)
	 */
	function publish($publish = 1) {

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');
		$mainframe = &JFactory::getApplication();
		$cid = JRequest::getVar('cid');
		
		// referencing JTable instance
		$row = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$msg = false;		

		// handling multiple slideshows
		foreach ($cid as $id) {
			$row->load($id);
			
			// publish/unpublish slideshow
			$row->publish($id, $publish);

			// calling CU3ER-generated.xml generator (XML contains <published> node)		
			if (!Cu3erFile::generateXMLFile($row->id, $num)) {
				$msg = 'COM_CU3ER_UNABLE_TO_WRITE_CU3ER_GENERATED.XML_FILE';		
			}
		}
		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();
		$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', JText::_($msg));
	}

	/**
	 * Slideshow unpublisher method
	 *
	 * @access public
	 */
	function unpublish() {
		$this->publish(0);
	}


	/**
	 * Slideshow duplicator method
	 *
	 * @access	public	
	 */
	function duplicate() {

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');

		$mainframe = &JFactory::getApplication();
		$db = & JFactory::getDBO();
		$cid = JRequest::getVar('cid', array (), 'post', 'array');

		$total = count($cid);

		// checking number of checked slideshows		
		if ($total < 1) {
			$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', JText::_('COM_CU3ER_YOU_MUST_CHECK_IN_AT_LEAST_ONE_SLIDESHOW_TO_DUPLICATE_IT'));			
		}

		// referencing JTable instances
		$ss_row = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$def_row = & JTable::getInstance('Cu3erDefault', 'Table');
		$sl_row = & JTable::getInstance('Cu3erSlide', 'Table');

		// cycling thru all slideshows		
		for ($i = 0; $i < $total; $i++) {

			$ss_query = "SELECT * FROM #__cu3er__slideshows " .
				    "WHERE id = {$cid[$i]}";

			$db->setQuery($ss_query);						

			$ss_result = $db->loadAssoc();
			
			// setting slideshow_id to null for the slideshow clone
			$ss_result['id'] = null;
			
			// counting instances of the same slideshow (and clones)
			$ss_name_query = "SELECT COUNT(id) FROM #__cu3er__slideshows " .
					 "WHERE name = '{$ss_result['name']}' " .
					 "OR name LIKE '%" . JText::_('COM_CU3ER_COPY_OF') . " " . $ss_result['name'] . "%'";

			$db->setQuery($ss_name_query);
			$copy_num = (int)$db->loadResult();

			// setting the name of new slideshow
			$ss_result['name'] = (($copy_num > 1)?'#' . $copy_num:'') . JText::_('COM_CU3ER_COPY_OF') . ' ' . $ss_result['name'];

			// binding, checking and storing cloned slideshow values
			if (!$ss_row->bind($ss_result) || !$ss_row->check() || !$ss_row->store()) {
				$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', $ss_row->getError(), 'error');
			} else {
				$slideshow_id = $ss_row->id;
			}

			// copying slideshow files			
			$this->duplicateSlideshowFiles($slideshow_id, $cid[$i]);

			// updating folder paths
			$this->updateSlideshowPaths($slideshow_id, $ss_row);

			$ss_row->checkin();	

			// resetting slideshow Active Record				
			$ss_row->reset();

			$def_query = "SELECT * FROM #__cu3er__defaults " .
				     "WHERE slideshow_id = {$cid[$i]}";

			$db->setQuery($def_query);						

			$def_result = $db->loadAssoc();
			
			// setting slideshow_id to null for the slide default clone
			$def_result['id'] = null;
			$def_result['slideshow_id'] = null;

			// binding, checking and storing cloned slide default values			
			if (!$def_row->bind($def_result) || !$def_row->check() || !$def_row->store()) {
				// removing slideshow db entry if storing failed 				
				$ss_row->delete($slideshow_id);

				// removing every slideshow files
				$this->deleteSlideshowFiles($slideshow_id);
				$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', $def_row->getError(), 'error');
			} else {
				// setting id and slideshow_id to null for the next possible slide default clone entry
				$def_row->id = null;
				$def_row->slideshow_id = null;
			}

			$def_row->checkin();	

			// updating slideshow_id in the slide default entry to the appropriate			
			$def_update_query =  "UPDATE #__cu3er__defaults SET slideshow_id = {$slideshow_id} " .
					     "WHERE slideshow_id = 0";

			$db->setQuery($def_update_query);
			$db->query();

			// slides getter query string			
			$sl_query = "SELECT * FROM #__cu3er__slides " .
				    "WHERE slideshow_id = {$cid[$i]}";

			// making SQL query
			$db->setQuery($sl_query);

			// getting query results into associative array
			$sl_results = $db->loadAssocList();

			// cycling thru every slide			
			foreach ($sl_results as $result) {
			
				$result['slideshow_id'] = $slideshow_id;
				$result['id'] = null;

				// binding, checking and storing cloned slide values
				if (!$sl_row->bind($result) || !$sl_row->check() || !$sl_row->store()) {
					// removing slideshow and slide default db entry if storing failed 					
					$ss_row->delete($slideshow_id);	
					$def_row->delete($slideshow_id);
					
					// removing every slideshow files					
					$this->deleteSlideshowFiles($slideshow_id);

					// removing previous slide db entries with the same slideshow_id
					$db->setQuery("DELETE FROM #__cu3er__slides WHERE slideshow_id = {$slideshow_id}");
					$db->query();
					
					$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', $sl_row->getError(), 'error');
				} else {
					// setting id to null for the next possible slide clone entry					
					$sl_row->set('id', null);
				}

				$sl_row->checkin();
			}

			// generation of the CU3ER-generated.xml file
			if (!Cu3erFile::generateXMLFile($slideshow_id)) {
				$msg = 'COM_CU3ER_UNABLE_TO_GENERATE_CU3ER_GENERATED.XML_FILE';
			} else {
				$msg = 'COM_CU3ER_SLIDESHOWS_DUPLICATED';						
			}
		}

		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();

		$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', JText::_($msg));
	}

	/**
	 * Slideshow file duplicator method
	 *
	 * @access public
	 * @param int $nsid ID of the new slideshow (clone)
	 * @param int $osid ID of the original slideshow
	 */
	function duplicateSlideshowFiles($nsid, $osid) {
		$config =& JComponentHelper::getParams('com_media');
		$folder = JPATH_COMPONENT_SITE . DS . 'slideshows';
		$img_path = JPATH_SITE . DS . ($config->get('image_path', 'images/stories')) . DS . 'CU3ER';
		
		// copying slideshow files
		JFolder::copy($folder . DS . $osid, $folder . DS . $nsid, null, true);
		JFolder::copy($img_path . DS . $osid, $img_path . DS . $nsid, null, true);
	}

	/**
	 * Slideshow path updater method
	 *
	 * @access public
	 * @param int $slideshow_id ID of the slideshow
	 * @param int $row	 referencing to the actual Cu3erSlideshow Table object
	 */
	function updateSlideshowPaths($slideshow_id, &$row) {
		$row->load($slideshow_id);

		$row->images_folder = preg_replace('/CU3ER\/(\d+)/', 'CU3ER/'.$slideshow_id, $row->images_folder);
		$row->fonts_folder = preg_replace('/slideshows\/(\d+)\/fonts/', 'slideshows/'.$slideshow_id.'/fonts', $row->fonts_folder);
		$row->xml_location = preg_replace('/slideshows\/(\d+)/', 'slideshows/'.$slideshow_id, $row->xml_location);

		if (!$row->check() || !$row->store()) {
			$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', $row->getError(), 'error');
		}
	}

	/**
	 * Slideshow file removal method
	 *
	 * @access public
	 * @param int $sid ID of the slideshow
	 */
	function deleteSlideshowFiles($sid) {

		$config =& JComponentHelper::getParams('com_media');

		$folder = JPATH_COMPONENT_SITE . DS . 'slideshows' . DS . $sid;
		$img_folder = JPATH_ROOT . DS . ($config->get('image_path', 'images/stories')) . DS . 'CU3ER' . DS . $sid;

		// removing slideshow files and slideshow image files		
		if (is_dir(JPath::clean($folder))) {		
			Cu3erFile::deleteAll($folder);		
		}

		if (is_dir(JPath::clean($img_folder))) {		
			Cu3erFile::deleteAll($img_folder);		
		}
	}

	/**
	 * Slideshow removal method
	 *
	 * @access public
	 */
	function remove() {
		
		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');
		
		$config =& JComponentHelper::getParams('com_media');

		$mainframe = &JFactory::getApplication();
		$db = & JFactory::getDBO();
		$cid = JRequest::getVar('cid', array (0), 'post', 'array');

		$total = count($cid);
		$first = true;

		$ss_where = "";
		$where = "";

		// generating WHERE clause for query
		foreach ($cid as $id) {
			$ss_where .= ((!$first)?"OR":"")." id = {$id} ";
			$where .= ((!$first)?"OR":"")." slideshow_id = {$id} ";
			$first = false;

			$this->deleteSlideshowFiles($id);
		}

		$ss_query = 'DELETE FROM #__cu3er__slideshows WHERE '.$ss_where;
		$def_query = 'DELETE FROM #__cu3er__defaults WHERE '.$where;
		$sl_query = 'DELETE FROM #__cu3er__slides WHERE '.$where;

		// making removal queries
		$db->setQuery($ss_query);
		$db->query();

		$db->setQuery($def_query);
		$db->query();

		$db->setQuery($sl_query);
		$db->query();

		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();

		$msg = JText::_('COM_CU3ER_SLIDESHOWS_REMOVED');
		$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', $msg);
	}
	
	function hasJavaScript($path) {
		$rootDir = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		$tempPath = explode("/", $path);
		$delFlag = true;
		for($i =0; $i<sizeof($tempPath); $i++) {
			if($delFlag) {
				if($tempPath[$i] == 'images') {
					$delFlag = false;
				} else {
					unset($tempPath[$i]);
				}
			}
		}
		$realPath = $rootDir . '/' . implode('/', $tempPath);
		return is_dir($realPath . '/fallback');
	}

}
?>